uses dos;
Type
  { enumerated font Type }
  ROMfont = (ROM8x14, ROM8x8, ROM8x16);

  CharDefTable = Array[0..4096] of Byte;
  CharDefPtr   = ^CharDefTable;

  Char_Table = Record
     Points :Byte;
     Def    :CharDefPtr;
  end;

  FontPackage = Record
     FontInfo :Char_Table;
  end;
  FontPkgPtr = ^FontPackage;

  tfontt=array[0..255,0..15] of byte;

var FONT:FontPackage;
    fonttoset:tfontt;
    reg:registers;i,l:integer;

Procedure GetCharGenInfo(Var Table:Char_Table);
begin
    Reg.AH := $11;
    Reg.AL := $30;
    Reg.BH := 6;
    Intr($10, Reg);
    Table.Def := Ptr(Reg.ES, Reg.BP);
    Table.Points := 16;
end;

Procedure setFont(tfont: pointer);
var ESr,BPr: Word;
    R: Registers;
Begin;
 ESr:=Seg(Tfont^);
 BPr:=Ofs(Tfont^);
 r.ax:=$1100;
 r.bh:=16;
 r.bl:=0;
 r.cx:=256;
 r.dx:=0;
 r.es:=Seg(Tfont^);
 r.bp:=Ofs(Tfont^);
 intr($10,r);
End;

begin
  GetCharGenInfo(font.FontInfo);
  with font.fontinfo do
       for i:=0 to 255 do for l:=0 to 15 do
           fonttoset[i,15-l]:=mem[seg(def^):ofs(def^)+(i*16)+l];

 setfont(addr(fonttoset));
end.
